package edu.jhmi.telometer.bean;

import edu.jhmi.telometer.interfce.Named;
import edu.jhmi.telometer.interfce.TreeObject;
import lombok.Builder;
import lombok.Data;
import lombok.ToString;
import lombok.experimental.Tolerate;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

@Entity
@Table(
        uniqueConstraints=
        @UniqueConstraint(columnNames={"projectId", "name"})
)
@Data
@Builder
public class Scoring implements Named, TreeObject {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne
    @JoinColumn(name="projectId", nullable=false)
    private Project project;

    @ManyToOne
    @JoinColumn(name="presetId", nullable=false)
    private Preset preset;

    @Basic
    @Column(nullable = false)
    private String name;

    @Basic
    @Column(nullable = false)
    private int cyBackground;

    @Basic
    @Column(nullable = false)
    private int dapiBackground;

    @Basic
    @Column(nullable = false)
    private long createdOn;

    @Basic
    @Column(nullable = false)
    private boolean isCy3Subtracted;


    @Tolerate
    public Scoring(){

    }

}
