package edu.jhmi.telometer.calc.impl;

import edu.jhmi.telometer.bean.Dimension;
import edu.jhmi.telometer.bean.Point;
import edu.jhmi.telometer.bean.Rect;
import edu.jhmi.telometer.calc.api.PositionConvertUtil;
import org.springframework.util.Assert;

import java.awt.Rectangle;

public class PositionConvertUtilImpl implements PositionConvertUtil {


    @Override
    public Point rectPointToAbsolutePoint(Rect rect, Point relativePoint) {
        int absoluteX = relativePoint.getX() + rect.getX();
        int absoluteY = relativePoint.getY() + rect.getY();
        Point absolutePoint = Point.builder().x(absoluteX).y(absoluteY).build();
        return absolutePoint;
    }

    @Override
    public Rect rectangleToRect(Rectangle rectangle) {
        Rect rect = Rect.builder().height((int) rectangle.getHeight()).width((int) rectangle.getWidth()).x((int) rectangle.getX()).y((int) rectangle.getY()).build();
        return rect;
    }

    @Override
    public int pointToPosition(Point point, Dimension dimension) {
        int width = dimension.getWidth();
        int position = (point.getY() * width) + point.getX();
        return position;
    }

    @Override
    public Point positionToPoint(int position, Dimension dimension) {
        int width = dimension.getWidth();
        int y = position / width;
        int x = position - (y * width);
        Point point = Point.builder().y(y).x(x).build();
        Assert.isTrue(position == pointToPosition(point, dimension), "bad positionToPoint");
        return point;
    }

    @Override
    public Dimension rectToDimension(Rect rect) {
        return Dimension.builder().width(rect.getWidth()).height(rect.getHeight()).build();
    }
}
