package edu.jhmi.telometer.util;

import lombok.Builder;
import lombok.Data;

import java.text.NumberFormat;

public class EnvironmentUtil {
    



    private static final String DEFAULT = "unknown";
    @Data
    @Builder
    public static class EnvironmentStat{
        private String javaVendor;
        private String javaVersion;
        private String osArch;
        private String osName;
        private String osVersion;
    }


    public static EnvironmentStat getEnvironmentStat(){
        EnvironmentStat environmentStat =
                EnvironmentStat.builder()
                        .javaVendor(prop("java.vendor"))
                        .javaVersion(prop("java.version"))
                        .osArch(prop("os.arch"))
                        .osName(prop("os.name"))
                        .osVersion(prop("os.version"))
                        .build();
        return environmentStat;
    }

    private static String prop(String propName){
        return System.getProperty(propName, DEFAULT);
    }

}
