package edu.jhmi.telometer.util;

import org.springframework.util.Assert;

import javax.swing.ImageIcon;
import java.io.IOException;
import java.io.InputStream;

public class IconUtil {

    public static ImageIcon getIcon(String nameWithoutPathOrExtension) {
        String fullName = String.format("icons/%s.png", nameWithoutPathOrExtension);
        try {
            InputStream inputStream = new IconUtil().getClass().getClassLoader().getResourceAsStream(fullName);
            Assert.notNull(inputStream, String.format("inputStream is null for path: '%s'", fullName));
            byte[] data = inputStream.readAllBytes();
            return new ImageIcon(data);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
