package edu.jhmi.telometer.util;

import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.TableModel;

public class TableUtil {

    public static void expandColumns(JTable table){
        TableModel tableModel = table.getModel();
        for (int i = 0; i < tableModel.getColumnCount(); i++){
            expandColumn(table, i);
        }
    }

    public static void expandColumn(JTable table, int modelColumnNumber){
        TableModel tableModel = table.getModel();
        int maxLength = tableModel.getColumnName(modelColumnNumber).length();
        for (int i = 0; i < tableModel.getRowCount(); i++) {
            Object object = tableModel.getValueAt(i, modelColumnNumber);
            int length = object != null ? object.toString().length() : 0;
            maxLength = Math.max(length, maxLength);
        }

        JTextField tempTextField = new JTextField(getSampleString(maxLength));
        int viewColumnNumber = table.convertColumnIndexToView(modelColumnNumber);
        table.getColumnModel().getColumn(viewColumnNumber).setPreferredWidth(
                tempTextField.getPreferredSize().width);
    }

    private static String getSampleString(int length) {
        StringBuffer s = new StringBuffer(length);
        for (int i = 0; i < length; i++) {
            s.append("A");
        }
        return s.toString();
    }
}
