package edu.jhmi.telometer.view.query.tree;

import edu.jhmi.telometer.interfce.TreeObject;
import edu.jhmi.telometer.interfce.TreePanelListener;
import edu.jhmi.telometer.util.FrameUtil;
import edu.jhmi.telometer.view.query.tree.NodeInfoPanel;
import edu.jhmi.telometer.view.query.tree.TreeOnlyPanel;
import lombok.extern.slf4j.Slf4j;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;

@Slf4j
public class TreePanel {

    private final JFrame frame = new JFrame("View");

    private boolean isInitted;

    private TreeOnlyPanel treeOnlyPanel = new TreeOnlyPanel();
    private NodeInfoPanel nodeInfoPanel = new NodeInfoPanel();

    public TreePanel(){
        initGuiIfNecessary();
    }

    private void initGuiIfNecessary() {
        FrameUtil.setInitialLocation(frame);
        if (isInitted) {
            return;
        }
        isInitted = true;
        treeOnlyPanel.init();

        treeOnlyPanel.setTreePanelListener(new TreePanelListener() {
            @Override
            public void treeObjectSelected(TreeObject treeObject) {
                nodeInfoPanel.setTreeObject(treeObject);
            }
        });

        JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        splitPane.add(treeOnlyPanel.getMainPanel());
        splitPane.add(new JScrollPane(nodeInfoPanel.getMainPanel()));

        frame.add(splitPane);
        frame.pack();
        int width = (int) (Toolkit.getDefaultToolkit().getScreenSize().getWidth() / 1.25);
        int height = (int) (Toolkit.getDefaultToolkit().getScreenSize().getHeight() / 1.25);
        frame.setSize(new Dimension(width, height));
        splitPane.setDividerLocation(width / 3);
    }

    public TreeOnlyPanel getTreeOnlyPanel(){
        return treeOnlyPanel;
    }

    public NodeInfoPanel getNodeInfoPanel() {
        return nodeInfoPanel;
    }

    public void display(){
        log.info("Displaying TreePanel");
        frame.setVisible(true);
    }
}
