package edu.jhmi.telometer.view.score;

import edu.jhmi.telometer.interfce.ScorePanelListener;
import edu.jhmi.telometer.thirdparty.SpringUtilities;
import edu.jhmi.telometer.util.IconUtil;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SpringLayout;
import java.awt.Component;


public class CompletePanel {

    private final JButton exportButton = new JButton("Export", IconUtil.getIcon("table"));
    private final JButton treeButton = new JButton("View", IconUtil.getIcon("tree"));


    private final JPanel mainPanel = new JPanel(new SpringLayout());
    private ScorePanelListener scorePanelListener;

    public CompletePanel(){
        JComponent[] components = {
                exportButton,
                treeButton,
        };
        for (Component component : components){
            mainPanel.add(component);
        }
        SpringUtilities.makeCompactGrid(mainPanel,
                components.length, 1,
                2, 40,
                40, 40);

        exportButton.addActionListener(a -> scorePanelListener.viewResultsInTableClicked());
        treeButton.addActionListener(a -> scorePanelListener.viewResultsInTreeClicked());
    }

    public JPanel getPanel() {
        return mainPanel;
    }

    public void setScorePanelListener(ScorePanelListener scorePanelListener) {
        this.scorePanelListener = scorePanelListener;
    }
}
