package edu.jhmi.telometer.view;

import edu.jhmi.telometer.controller.GeneralController;
import edu.jhmi.telometer.util.DbPopulator;
import ij.util.ThreadUtil;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.Properties;

@SpringBootTest
@Slf4j
//@Disabled
class GeneralControllerTest {


    @Autowired
    private GeneralController generalController;

    @Autowired
    private DbPopulator dbPopulator;

    @BeforeEach
    public void before() {
        dbPopulator.removeEverything();
        dbPopulator.populateDbLookupTables();
        dbPopulator.populateDbWithTestData();
    }

    @Test
    public void generalControllerTest() throws InterruptedException {
        log.info("starting generalControllerTest");
        generalController.startup();
        log.trace("sleeping indefinitely...");
        Thread.sleep(60 * 30 * 1000);
    }

    @Test
    public void vars(){
        log.info("env: {}", System.getenv());
        log.info("properties: {}", System.getProperties());
        Properties properties = System.getProperties();
        for (Object key : properties.keySet()){
            log.info("{}: {}", key, properties.get(key));
        }
    }
}